# Class DropTargetDragEvent

java.lang.Object
java.util.EventObject
java.awt.dnd.DropTargetEvent
java.awt.dnd.DropTargetDragEvent

All Implemented Interfaces:
  `Serializable`

public class DropTargetDragEvent extends DropTargetEvent
The `DropTargetDragEvent` is delivered to a `DropTargetListener` via its dragEnter() and dragOver() methods.

The `DropTargetDragEvent` reports the source drop actions and the user drop action that reflect the current state of the drag operation.

Source drop actions is a bitwise mask of `DnDConstants` that represents the set of drop actions supported by the drag source for this drag operation.

User drop action depends on the drop actions supported by the drag source and the drop action selected by the user. The user can select a drop action by pressing modifier keys during the drag operation:

      Ctrl + Shift -> ACTION_LINK
      Ctrl         -> ACTION_COPY
      Shift        -> ACTION_MOVE

If the user selects a drop action, the user drop action is one of `DnDConstants` that represents the selected drop action if this drop action is supported by the drag source or `DnDConstants.ACTION_NONE` if this drop action is not supported by the drag source.

If the user doesn't select a drop action, the set of `DnDConstants` that represents the set of drop actions supported by the drag source is searched for `DnDConstants.ACTION_MOVE`, then for `DnDConstants.ACTION_COPY`, then for `DnDConstants.ACTION_LINK` and the user drop action is the first constant found. If no constant is found the user drop action is `DnDConstants.ACTION_NONE`.

Since:
  1.2
See Also:
  - Serialized Form

- ## Field Summary

  ### Fields declared in class DropTargetEvent

  `context`
  Modifier and Type
  Field
  Description
  `protected DropTargetContext`
  `context`
  The `DropTargetContext` associated with this `DropTargetEvent`.

  ### Fields declared in class EventObject

  `source`
  Modifier and Type
  Field
  Description
  `protected Object`
  `source`
  The object on which the Event initially occurred.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DropTargetDragEvent(DropTargetContext dtc, Point cursorLocn, int dropAction, int srcActions)`
  Construct a `DropTargetDragEvent` given the `DropTargetContext` for this operation, the location of the "Drag" `Cursor`'s hotspot in the `Component`'s coordinates, the user drop action, and the source drop actions.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `acceptDrag(int dragOperation)`
  Accepts the drag.
  `DataFlavor[]`
  `getCurrentDataFlavors()`
  This method returns the current `DataFlavor`s from the `DropTargetContext`.
  `List<DataFlavor>`
  `getCurrentDataFlavorsAsList()`
  This method returns the current `DataFlavor`s as a `java.util.List`
  `int`
  `getDropAction()`
  This method returns the user drop action.
  `Point`
  `getLocation()`
  This method returns a `Point` indicating the `Cursor`'s current location within the `Component'`s coordinates.
  `int`
  `getSourceActions()`
  This method returns the source drop actions.
  `Transferable`
  `getTransferable()`
  This method returns the Transferable object that represents the data associated with the current drag operation.
  `boolean`
  `isDataFlavorSupported(DataFlavor df)`
  This method returns a `boolean` indicating if the specified `DataFlavor` is supported.
  `void`
  `rejectDrag()`
  Rejects the drag as a result of examining either the `dropAction` or the available `DataFlavor` types.

  ### Methods declared in class DropTargetEvent

  `getDropTargetContext`
  Modifier and Type
  Method
  Description
  `DropTargetContext`
  `getDropTargetContext()`
  This method returns the `DropTargetContext` associated with this `DropTargetEvent`.

  ### Methods declared in class EventObject

  `getSource, toString`
  Modifier and Type
  Method
  Description
  `Object`
  `getSource()`
  The object on which the Event initially occurred.
  `String`
  `toString()`
  Returns a String representation of this EventObject.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### DropTargetDragEvent

    public DropTargetDragEvent(DropTargetContext dtc, Point cursorLocn, int dropAction, int srcActions)
    Construct a `DropTargetDragEvent` given the `DropTargetContext` for this operation, the location of the "Drag" `Cursor`'s hotspot in the `Component`'s coordinates, the user drop action, and the source drop actions.
    Parameters:
      `dtc` - The DropTargetContext for this operation
      `cursorLocn` - The location of the "Drag" Cursor's hotspot in Component coordinates
      `dropAction` - The user drop action
      `srcActions` - The source drop actions
    Throws:
      `NullPointerException` - if cursorLocn is null
      `IllegalArgumentException` - if dropAction is not one of `DnDConstants`.
      `IllegalArgumentException` - if srcActions is not a bitwise mask of `DnDConstants`.
      `IllegalArgumentException` - if dtc is `null`.

- ## Method Details

  - ### getLocation

    public Point getLocation()
    This method returns a `Point` indicating the `Cursor`'s current location within the `Component'`s coordinates.
    Returns:
      the current cursor location in `Component`'s coords.

  - ### getCurrentDataFlavors

    public DataFlavor[] getCurrentDataFlavors()
    This method returns the current `DataFlavor`s from the `DropTargetContext`.
    Returns:
      current DataFlavors from the DropTargetContext

  - ### getCurrentDataFlavorsAsList

    public List<DataFlavor> getCurrentDataFlavorsAsList()
    This method returns the current `DataFlavor`s as a `java.util.List`
    Returns:
      a `java.util.List` of the Current `DataFlavor`s

  - ### isDataFlavorSupported

    public boolean isDataFlavorSupported(DataFlavor df)
    This method returns a `boolean` indicating if the specified `DataFlavor` is supported.
    Parameters:
      `df` - the `DataFlavor` to test
    Returns:
      `true` if a particular `DataFlavor` is supported, otherwise `false`

  - ### getSourceActions

    public int getSourceActions()
    This method returns the source drop actions.
    Returns:
      the source drop actions

  - ### getDropAction

    public int getDropAction()
    This method returns the user drop action.
    Returns:
      the user drop action

  - ### getTransferable

    public Transferable getTransferable()
    This method returns the Transferable object that represents the data associated with the current drag operation.
    Returns:
      the Transferable associated with the drag operation
    Throws:
      `InvalidDnDOperationException` - if the data associated with the drag operation is not available
    Since:
      1.5

  - ### acceptDrag

    public void acceptDrag(int dragOperation)
    Accepts the drag. This method should be called from a `DropTargetListeners dragEnter`, `dragOver`, and `dropActionChanged` methods if the implementation wishes to accept an operation from the srcActions other than the one selected by the user as represented by the `dropAction`.
    Parameters:
      `dragOperation` - the operation accepted by the target

  - ### rejectDrag

    public void rejectDrag()
    Rejects the drag as a result of examining either the `dropAction` or the available `DataFlavor` types.